import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import 'models.dart';

class M4eBalance extends Equatable {
  final double value;
  final M4eCurrencyType unit;

  const M4eBalance({@required this.value, @required this.unit});

  factory M4eBalance.fromJson(Map<String, dynamic> json) {
    return M4eBalance(
      value: json['balance']['value'],
      unit: M4eCurrencyType.parse(json['balance']['unit']),
    );
  }

  Map<String, dynamic> toJson() {
    return {
      'balance': {
        'value': this.value,
        'unit': this.unit.toString(),
      }
    };
  }

  @override
  List<Object> get props => [value, unit];

  @override
  bool get stringify => true;
}
