import 'package:equatable/equatable.dart';

import '../core/core.dart';

abstract class M4eAccessPermissionSet extends Equatable {
  const M4eAccessPermissionSet();
}

class EntityEntityAccess extends M4eAccessPermissionSet {
  final String _permission;

  static const M4eAccessPermissionType TYPE =
      M4eAccessPermissionType.ENTITY_ENTITY;

  const EntityEntityAccess._(this._permission);

  static const see = EntityEntityAccess._('SEE');
  static const contact = EntityEntityAccess._('CONTACT');

  factory EntityEntityAccess.parse(String permission) {
    return EntityEntityAccess._(permission);
  }

  @override
  List<Object> get props => [_permission];

  @override
  String toString() => '$_permission';
}

class EntityWalletAccess extends M4eAccessPermissionSet {
  final String _permission;

  static const M4eAccessPermissionType TYPE =
      M4eAccessPermissionType.ENTITY_WALLET;

  const EntityWalletAccess._(this._permission);

  static const see = EntityWalletAccess._('SEE');
  static const view = EntityWalletAccess._('VIEW');
  static const pay = EntityWalletAccess._('PAY');
  static const grant = EntityWalletAccess._('GRANT');
  static const alter = EntityWalletAccess._('ALTER');
  static const create = EntityWalletAccess._('CREATE');
  static const destroy = EntityWalletAccess._('DESTROY');

  factory EntityWalletAccess.parse(String permission) {
    return EntityWalletAccess._(permission);
  }

  @override
  List<Object> get props => [_permission];

  @override
  String toString() => '$_permission';
}

class WalletWalletAccess extends M4eAccessPermissionSet {
  final String _permission;

  static const M4eAccessPermissionType TYPE =
      M4eAccessPermissionType.WALLET_WALLET;

  const WalletWalletAccess._(this._permission);

  static const payTo = WalletWalletAccess._('PAY_TO');
  static const receiveFrom = WalletWalletAccess._('RECEIVE_FROM');

  factory WalletWalletAccess.parse(String permission) {
    return WalletWalletAccess._(permission);
  }

  @override
  List<Object> get props => [_permission];

  @override
  String toString() => '$_permission';
}
